package com.io.yutian.colorblindwar;

import com.io.yutian.colorblindwar.game.DirectionPoint;
import com.io.yutian.colorblindwar.game.Game;
import com.io.yutian.colorblindwar.listener.PlayerListener;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

public final class ColorblindWar extends JavaPlugin {

    private static ColorblindWar instance;
    private static Game game;

    @Override
    public void onEnable() {
        instance = this;
        game = new Game();
        Bukkit.getPluginManager().registerEvents(new PlayerListener(), this);
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if (args.length == 0) {
            sender.sendMessage("/cw create - 创建游戏");
            sender.sendMessage("/cw start - 开始游戏");
            sender.sendMessage("/cw stop - 结束游戏");
            sender.sendMessage("/gw reload - 重载");
            return true;
        } else {
            String subCommand = args[0];
            if (subCommand.equalsIgnoreCase("create")) {
                if (!(sender instanceof Player)) {
                    sender.sendMessage("非玩家无法创建游戏");
                    return true;
                }
                Player player = (Player) sender;
                game.setWorld(player.getWorld());
                game.setSpawnPoint(DirectionPoint.of(player.getLocation()));
                game.reload();
                player.sendMessage("成功创建游戏");
            } else if (subCommand.equalsIgnoreCase("start")) {
                if (!(sender instanceof Player)) {
                    sender.sendMessage("非玩家无法开始游戏");
                    return true;
                }
                if (game.isStarted()) {
                    sender.sendMessage("游戏已开始");
                    return true;
                }
                Player player = (Player) sender;
                game.start(player);
            } else if (subCommand.equalsIgnoreCase("stop")) {
                if (!game.isStarted()) {
                    sender.sendMessage("游戏未开始");
                    return true;
                }
                Player player = (Player) sender;
                game.stop(false);
            } else if (subCommand.equalsIgnoreCase("reload")) {
                game.reload();
                sender.sendMessage("重载成功");
            } else if (subCommand.equalsIgnoreCase("test")) {
                if (args[1].equalsIgnoreCase("spawn")) {
                    game.spawnBuild();
                } else if (args[1].equalsIgnoreCase("clear")) {
                    game.clearBlock();
                } else if (args[1].equalsIgnoreCase("v")) {
                    game.vanishBlock();
                }
            }
        }
        return true;
    }

    public static ColorblindWar inst() {
        return instance;
    }

    public static Game getGame() {
        return game;
    }

}
